#ifndef VDDIRECT3D_H
#define VDDIRECT3D_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <d3d9.h>
#include <d3dx9.h>
#include <windows.h>
#include <list>
#include "VDSprite.h"
#include "VDError.h"
using namespace std;



/* **********************************************************************************************************************
   Linked Libraries
   **********************************************************************************************************************/

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")



/* **********************************************************************************************************************
   VDDirect3D
   **********************************************************************************************************************/

class VDDirect3D {
public:
    VDDirect3D();
    virtual ~VDDirect3D();

    void InitializeDirect3D(HWND window);
    void Render(const RECT *area, int windowWidth, int windowHeight, int userLocationX, int userLocationY);
    void Render(const RECT *area, HWND window, VDSprite *aSprite);
    VDSprite* AddSprite(LPCTSTR textureFile, float x, float y, int width, int height, int isStatic, int isNPC);
    void RemoveTileSprite(float x, float y);
    void RemoveSprites();
    void MovingPlayer(int direction);
    char* AddText(char *theMessage, int theLeft, int theTop, int theRight, int theBottom, D3DCOLOR theColor);
    void RemoveText(char *theMessage);
    void RemoveTexts();

    LPDIRECT3DDEVICE9 GetDirect3DRenderer();
    LPD3DXSPRITE GetSpriteRenderer();
    int IsMoving();
private:
    typedef struct Text {
            RECT textBox;
            char message[500];
        D3DCOLOR color;
    };
                LPDIRECT3D9 direct3D;                // Direct3D
          LPDIRECT3DDEVICE9 direct3DDevice;          // display adapter device
      D3DPRESENT_PARAMETERS presentationParameters;  // presentation parameters
             list<VDSprite> sprites;                 // list of the sprites
               LPD3DXSPRITE sprite;                  // sprite rendering unit
                        int isMoving;                // is the sprite in the process of moving?
                        int movingDirection;         // direction of movement
                        int movingDuration;          // current ticker
                 LPD3DXFONT font;                    // font for displaying text
                 list<Text> text;
};



#endif  // VDDIRECT3D_H