#ifndef VDSPRITE_H
#define VDSPRITE_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <d3d9.h>
#include <d3dx9.h>
#include "VDError.h"



/* **********************************************************************************************************************
   VDSprite
   **********************************************************************************************************************/

class VDSprite {
public:
    VDSprite();
    VDSprite(LPDIRECT3DDEVICE9 direct3DDevice, LPCSTR textureFile, int x, int y, D3DXVECTOR3 aCenter, D3DXVECTOR3 aPosition, D3DCOLOR aColor, int isStaticSprite, int isNPCSprite);
    virtual ~VDSprite();

    void Draw(LPD3DXSPRITE sprite);
    void ShiftLocation(LPDIRECT3DDEVICE9 direct3DDevice, float x, float y);

    D3DXVECTOR3 GetPosition();
          int IsStatic();
          int IsNPC();
          int IsDead();
           void AddToPosition(int x, int y);
           void KillSprite();
protected:
private:
    LPDIRECT3DTEXTURE9 texture;
                  RECT sourceRectangle;
           D3DXVECTOR3 center;
           D3DXVECTOR3 position;
              D3DCOLOR color;
                 int isStatic;
                 int isNPC;
                 int isDead;
};



#endif