#ifndef VDWORLD_H
#define VDWORLD_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDTile.h"



/* **********************************************************************************************************************
   VDWorld
   **********************************************************************************************************************/

class VDWorld {
public:
    VDWorld();
    ~VDWorld();

     void CreateWorld(const char *fileName);
     void LoadWorld(const char *fileName);
    int ReallocateWorld(int worldMouseLocationX, int worldMouseLocationY);
    int CheckNewLocation(int direction, int entityLocationX, int entityLocationY);

    VDTile GetTile(int x, int y);
    LPCTSTR GetTileImageFileLocation(int x, int y);
      void SetTileStatus(int x, int y, int theStatus);
      void SetTileImageFileLocation(int x, int y, const char *theImageFileLocation);
      void SetTileSpawns(int x, int y, list<VDSpawn> theSpawns);
       int GetWorldSizeX();
       int GetWorldSizeY();
protected:
private:
    enum Status {
        NA,
        OPEN,
        BLOCKED,
        NEWAREA
    };

    VDTile **world;
    int worldSizeX;
    int worldSizeY;
};



#endif